# Contribution Guidelines

## Did you find a bug?

* Ensure the bug was not already reported by searching on Github under
  Issues.
* If you're unable to find an open issue addressing the problem, open a new
  one. Be sure to include a title and clear description, as much relevant
  information as possible, and a code sample or an executable test case
  demonstrating the expected behavior that is not occurring.
* If possible, use the relevant bug report template to create the issue.

## Did you fix a bug?

* Open a new Github pull-request with the patch.
* Ensure the PR description clearly describes the problem and solution.
  Include the relevant issue number if applicable.

## Do you intend to add a new feature, or change an existing one?

* Open an issue on Github to get a discussion going first before
  proceeding.
* Open individual issues for each suggested feature, and individual
  pull-requests for each one.
* New features being introduce should include unit tests and
  documentation where necessary.

## Are you opening a pull-request?

* The pull request should have a useful title
* Please make sure your commits follow **Result**'s
  [commit standards](../doc/commit-standards.md)
* Please follow the existing conventions of the library for new contributions
* Keep descriptions short and simple, but descriptive.
* Start the description with a capital and end with a full stop/period.
* Check your spelling and grammar.
* Make sure your text editor is set to remove trailing whitespace.

## Do you have any questions about the library?

* Open a Github issue with a title indicating the question.
